package jp.fujiwhara;

import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;
import java.util.LinkedList;

public class calc {

/*
  MakeTenの全順列に対して、全ての四則演算のコンビネーションを設定する。
  
  20220313修正(by myself)
			(((a b) c) d)でカバーされると思っていたが、(a b) (c d)は含まれなくなる（カッコで
			優先順位がかわらない演算子はカバーされるが）
			よって、後者も取り扱う。その場合、五桁以上はしんどいので、カバーしないことにする。
			一方、五桁は(a b c) (d e)でカバーされるはずなので、五桁までカバーするよう修正。　
  
  
  この目的限定なので、めんどくさいのであまりきちんとチェックはいれていない。

　クラス構成：
	SPEC：
	　親からは演算全重複順列を、必要桁数と箱となるリストを渡してもらったら、箱を埋めて返す処理をする。
	　実装は、親から受け取る取りがメソッドaccmが、実際の処理メソッドsubaccmに渡し、Listを完成させ終了する
	　再帰処理なので戻り値は無し。
	
	　さらに、そのリストを組み合わせて10になるか検証するメソッド


　　メソッド
	accm():		四則演算を蓄積するリスト作成メソッド。全組み合わせはサブメソッドになげている
		引数	digits: 作成すべき桁。文字数マイナス１が渡されてくるはず。あくまでも「渡された桁を生成」の実装。
				lst:　全組合わせを１行ずつのリストにする、そのリストの参照渡しのためリストを引数に
		戻り値　桁数によって変わる再起処理のため、渡されたポインターに編集するので戻りは無し。
		Local変数　ループカウンターi。それぞれ一桁目の記号をトリガーとしてn-1までの樹状展開をsubaccmで実施
					0:plus
					1:minus
					2:multiple
					3:divide
					(20220313)
					4: reverse minus
					5: reverse divide
				 を当てはめる前提でリストを返す。
		
	subaccm():	Heapのように、メソッドの中に、最初なのかどうなのかチェックすれば、入れ子にしなくて済むが、まあよい
				実際に四則演算の全く見合わせを生成する。これは、文字列間に四則演算を全可能性
				あてはめることが目的なのでn文字ならn-1個の演算場所に４つを全組み合わせあてはめる
				この操作には、n-1個の場所に順番に４ついれる、というのをrecursiveに処理
		引数	int i: n-1個の場所のなかの、現在処理中の場所
				int j:　i桁目の処理対象の桁に入れるべき記号として渡される
				lst: 桁が終わったら、そこで終了させ書き込むが、そのためのリスト。親プロセスからの参照渡しで孫請。ちょっと汚いけど、、、

	mktn():		Make Tenを、文字列順列と四則重複順列を総当たりで評価する。
		引数：	 digits: 評価ターゲットの桁数
				trgt: ターゲット文字列順列のリスト
				cmpt: ターゲットをcomputeする四則演算リスト
				tgtfg:　10以外を指定する場合
		戻り値：　参照渡しのListで、voidと変更した。(obsolete  10となったく見合わせをStringとして戻す)

*/
	static String tmpOprt = ""; //四則演算子文字群を文字列にする.初期化しとかないと最初にNullが残ってしまう
								//別にクラス変数でなくてもよいか、、、ブロック完結するんで。
	static int[] sym;	//記号を桁数分集めて文字列にするための文字群の配列。子メソッドでインスタンス化孫メソッドで処理なのでクラススコープに
	static String clsym=""; //↑を放り込む文字列
	static int dgt_cls; //桁数はやはり全メソッドで見えるようにしたいので、親から受け取ったらクラス変数にほうりこんで参照

	public static void accm(int dgts, List<String> lst) {
		sym = new int[dgts]; //クラススコープ、、だよね
		dgt_cls = dgts; //受け取った桁数をクラスの静的変数として扱う
		for (int i = 0; i < 6; i++) {
			subaccm(0, i, lst);
		}
	}

	static void subaccm(int i, int j, List<String> lst) { //publicにしなくてもよいよね
		sym[i] = j;

		if (i == dgt_cls - 1) {  //ここが最後なら、リストに書き込んで終わり
			for (int n = 0; n < dgt_cls; n++) {
				clsym = clsym + sym[n];
			}
			lst.add(clsym);
			clsym = "";
		}else {

			i++;
			for (int k = 0; k < 6; k++) {
				subaccm(i, k, lst);
			}
		}
	}

	static double exec(double lft, double rght, int sgn){
		double clcrs=0.0;
		switch(sgn){
			case 0:
				clcrs = lft + rght;
				break;
			case 1:
				clcrs = lft - rght;
				break;
			case 2:
				clcrs = lft * rght;
				break;
			case 3:
				clcrs = lft / rght;
				break;
			case 4:
				clcrs = rght - lft;
				break;
			case 5:
				clcrs = rght / lft;
				break;
		}
		return clcrs;
	}


	public static void mktn(int digits, List<String> trgt, List<String> cmpt, List<String> rslt, int tgtfg){
//		String rslt=""; //VBやCなら、そもそも戻り値は関数名mktnなので、それで動くか確認する
//			やはり関数名と戻り値名は違う。そして、20220313修正時にリストインスタンスを返す修正
		String rsltmp = ""; //戻り値となるのは、有効結果の群。そこに乗せる前に評価するまで保管するバッファ文字列
		char[] indv;
		double clcn=0.0; //左から順番の計算結果保管場所
		
		String sgn[] = {"+", "-", "*", "/", "sw-", "sw/"};

		for(String itm: trgt){
			indv = itm.toCharArray(); 
			
			for(String ent: cmpt){
				clcn = (long)indv[0] - 48; //char -> doubleは、Cとかとちがい暗黙的にcastされるが、わかりにくい。。一旦明示的に整数にcastして、doubleに
				rsltmp = "" + indv[0] ; //""でStringを明示的に宣言しておく、さもないとキャストされず型違いでエラー
				
				//左から順番のケース：任意の桁数に対応
				for(int j=1; j < digits; j++){
					if (ent.substring(j-1,j).equals("0")){  //なぜかSwitch　Breakでは全ループ出ちゃう、、自分だけじゃないのか、、、
						clcn = clcn + ((long)indv[j] - 48);
						rsltmp = "(" + rsltmp + "+" + indv[j] + ")";
					}else if(ent.substring(j-1,j).equals("1")){
						clcn = clcn - ((long)indv[j] - 48);
						rsltmp = "(" + rsltmp + "-" + indv[j] + ")";
					}else if(ent.substring(j-1,j).equals("2")){
						clcn = clcn * ((long)indv[j] - 48);
						rsltmp = "(" + rsltmp + "*" + indv[j] + ")";
					}else if(ent.substring(j-1,j).equals("3")){
						clcn = clcn / ((long)indv[j] - 48);
						rsltmp = "(" + rsltmp + "/" + indv[j] + ")";
					}else if(ent.substring(j-1,j).equals("4")){
						clcn = ((long)indv[j] - 48) - clcn;
						rsltmp = "(" + rsltmp + "sw-" + indv[j] + ")";
					}else{
						clcn = ((long)indv[j] - 48) / clcn;
						rsltmp = "(" + rsltmp + "sw/" + indv[j] + ")";
					}
				}
				if (clcn == tgtfg){
					if( ! rslt.contains(rsltmp)){
						rslt.add(rsltmp);
					}
				}else if (clcn>tgtfg-0.00001 && clcn<tgtfg + 0.00001){
//フローティングの誤差をすくい上げる。まぁないでしょう
					if( ! rslt.contains(rsltmp + "?")){
						rslt.add(rsltmp + "?");
					}
				}
			
				//ふたつかっこのケースをカバーさせる。四桁、五桁のみ対応。ここからが大きな変更（加筆）
				
				//まず四桁か五桁のみにしぼって、処理します。
				
				if(digits == 4){
				//4桁なら、(a b) (c d)　前者をclcn、後者をclc2で最後にがちゃんこ
				//桁が決まってるので、ループ回さなくて指定で一気に決着
				
					int op1 = Integer.parseInt(ent.substring(0,1));
					int op2 = Integer.parseInt(ent.substring(1,2));
					int op3 = Integer.parseInt(ent.substring(2,3));

					double ag1 = (double)indv[0]-48.0;
					double ag2 = (double)indv[1]-48.0;
					double ag3 = (double)indv[2]-48.0;
					double ag4 = (double)indv[3]-48.0;
					

					clcn = exec(exec(ag1, ag2, op1), exec(ag3, ag4, op3), op2);
					rsltmp = "(" + indv[0] + sgn[op1] + indv[1] + ")" + sgn[op2] + "(" + indv[2] + sgn[op3] + indv[3] + ")";

					if (clcn == tgtfg){
						if( ! rslt.contains(rsltmp)){
							rslt.add(rsltmp);
						}
					}else if (clcn>tgtfg-0.00001 && clcn<tgtfg + 0.00001){
//フローティングの誤差をすくい上げる。まぁないでしょう
						if( ! rslt.contains(rsltmp + "?")){
							rslt.add(rsltmp + "?");
						}
					}

				}else if (digits == 5) {
				//5桁なら、(a b c) (d e)だけだと思ってるけど、、、　
								
					int op1 = Integer.parseInt(ent.substring(0,1));
					int op2 = Integer.parseInt(ent.substring(1,2));
					int op3 = Integer.parseInt(ent.substring(2,3));
					int op4 = Integer.parseInt(ent.substring(3,4));

					double ag1 = (double)indv[0]-48.0;
					double ag2 = (double)indv[1]-48.0;
					double ag3 = (double)indv[2]-48.0;
					double ag4 = (double)indv[3]-48.0;
					double ag5 = (double)indv[4]-48.0;
					

					clcn = exec(exec(exec(ag1, ag2, op1), ag3, op2), exec(ag4, ag5, op4), op3);
					rsltmp = "((" + indv[0] + sgn[op1] + indv[1] + ")" + sgn[op2] + indv[2] + ")" + sgn[op3] + "(" + indv[3] + sgn[op4] + indv[4] + ")";
					if (clcn == tgtfg){
						if( ! rslt.contains(rsltmp)){
							rslt.add(rsltmp);
						}
					}else if (clcn>tgtfg-0.00001 && clcn<tgtfg + 0.00001){
//フローティングの誤差をすくい上げる。まぁないでしょう
						if( ! rslt.contains(rsltmp + "?")){
							rslt.add(rsltmp + "?");
						}
					}
				}
			}
		}
//		return(rslt);
	}
}