package jp.fujiwhara;

import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;
import java.util.LinkedList;
//import java.util.HashMap;

public class permutation {

/*
//SPEC
  引数：
  　int rcsv	:樹形の何段目かを渡す自然数。１ずつ減じながら再起的に１までまわし、１で戻り値がでて終了。
    char[] Heap	:対象となるcharの配列。対象文字列の各文字をchar配列に分解。
				 この文字配列を直接スワップしながら全順列を生成するHeapアルゴリズムのため、「参照渡し」としての扱いが必須
				 また、生成した新しい順列要素ができたら、それを保存するリストも、各ルーチンで共有するため、こちらも「参照渡し」が必須
				 現時点で、Java仕様は、配列（Array）、Listは「参照の値渡し」（ほぼ参照渡しと等価）
	List<String> trgt:　Heap配列の並べ替えでできた新しい順列を保存していくためのリスト
	
　変数
	宣言時に説明
	ループカウンターは、int i, j。
	 

　戻り値：
	なし。再起的に処理し、グローバルスコープのリストを更新していく。
	リストのグローバルがダメになったら、ローカルファイルにAppendしていく形式でも可かな、、

　並べ替えアルゴリズムは
　　　https://ja.wikipedia.org/wiki/Heapのアルゴリズム
　を参照しました。ありがとうございました。
/////////////////////////////////////////////////////////////////////////////////////////////
CAUTION! このクラスは、再帰的に使うので、戻り値がなく、メモリは圧迫があり得ます。メモリ最適化はしていません。
Exception処理もいれていません。
/////////////////////////////////////////////////////////////////////////////////////////////


*/

//Start Declaring Class Variables
	static String tmpHeap = ""; //組み替え済みHeap配列文字群を文字列にする.初期化しとかないと最初にNullが残ってしまう
	
//Start Methods
//順列の簡単なアルゴリズムを発見したHeap氏に敬意を評し、Heapを配列名に採用
	public static void permutation(int rcsv, char[] Heap, List<String> trgt){
		char tmp; //Swapのときに、一時退避のための場所		
		
		if (rcsv == 1) {  //再帰的に何度もまわすので、ポインター自体を引数として渡し、止めるか回すかが判断される
			for (int i = 0; i < Heap.length; i++) {
				tmpHeap = tmpHeap + Heap[i];
			}
			trgt.add(tmpHeap);
			tmpHeap = "";
			
		}else{
			for(int j = 0; j < rcsv; j++){
				permutation(rcsv - 1, Heap, trgt);
				if (rcsv % 2 == 0){   //swapのブロック
					tmp = Heap[j];
					Heap[j] = Heap[rcsv-1];
					Heap[rcsv-1]=tmp;
				}else{
					tmp = Heap[0];
					Heap[0] = Heap[rcsv-1];
					Heap[rcsv-1]=tmp;
				}
			}
		}
	}
}